Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file radiation_model_mod.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,14 @@
 ! -----------------
 ! $Id$
+! - Improved reading/writing of SVF from/to file (BM)
+! - Bugfixes concerning RRTMG as well as average_radiation options (M. Salim)
+! - Revised initialization of surface albedo and some minor bugfixes (MS)
+! - Update net radiation after running radiation interaction routine (MS)
+! - Revisions from M Salim included
+! - Adjustment to topography and surface structure (MS)
+! - Initialization of albedo and surface emissivity via input file (MS)
+! - albedo_pars extended (MS)
+! 
+! 2604 2017-11-06 13:29:00Z schwenkel
 ! bugfix for calculation of effective radius using morrison microphysics
 ! 
@@ -179,4 +189,5 @@
 !> @todo Output of other rrtm arrays (such as volume mixing ratios)
 !> @todo Adapt for use with topography
+!> @todo Optimize radiation_tendency routines
 !>
 !> @note Many variables have a leading dummy dimension (0:0) in order to
@@ -188,6 +199,9 @@
         ONLY:  dzw, hyp, nc, pt, q, ql, zu, zw
 
+    USE calc_mean_profile_mod,                                                 &
+        ONLY:  calc_mean_profile
+
     USE cloud_parameters,                                                      &
-        ONLY:  cp, l_d_cp, rho_l
+        ONLY:  cp, l_d_cp, r_d, rho_l
 
     USE constants,                                                             &
@@ -195,8 +209,15 @@
 
     USE control_parameters,                                                    &
-        ONLY:  cloud_droplets, cloud_physics, g, initializing_actions,         &
+        ONLY:  cloud_droplets, cloud_physics, coupling_char, dz, g,            &
+               initializing_actions, io_blocks, io_group,                      &
                latitude, longitude, large_scale_forcing, lsf_surf,             &
-               microphysics_morrison, pt_surface, rho_surface,                 &
-               surface_pressure, time_since_reference_point
+               message_string, microphysics_morrison, pt_surface,              &
+               rho_surface, surface_pressure, time_since_reference_point
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point, log_point_s
+
+    USE grid_variables,                                                        &
+         ONLY:  ddx, ddy, dx, dy 
 
     USE date_and_time_mod,                                                     &
@@ -205,5 +226,8 @@
 
     USE indices,                                                               &
-        ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
+        ONLY:  nnx, nny, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg,   &
+               nzb, nzt
+
+    USE, INTRINSIC :: iso_c_binding
 
     USE kinds
@@ -216,4 +240,13 @@
 #endif
 
+    USE netcdf_data_input_mod,                                                 &
+        ONLY:  albedo_type_f, albedo_pars_f, building_type_f, pavement_type_f, &
+               vegetation_type_f, water_type_f
+
+    USE plant_canopy_model_mod,                                                &
+        ONLY:  plant_canopy, pc_heating_rate, lad_s, usm_lad_rma
+
+    USE pegrid
+
 #if defined ( __rrtmg )
     USE parrrsw,                                                               &
@@ -235,6 +268,10 @@
         ONLY:  rrtmg_sw
 #endif
+    USE statistics,                                                            &
+        ONLY:  hom
+
     USE surface_mod,                                                           &
-        ONLY:  get_topography_top_index
+        ONLY:  get_topography_top_index, surf_def_h, surf_def_v, surf_lsm_h,   &
+               surf_lsm_v, surf_type, surf_usm_h, surf_usm_v
 
     IMPLICIT NONE
@@ -281,5 +318,4 @@
                                                          /)
 
-
     INTEGER(iwp) :: albedo_type  = 9999999, & !< Albedo surface type
                     dots_rad     = 0          !< starting index for timeseries output 
@@ -291,6 +327,12 @@
                 radiation = .FALSE.,                  & !< flag parameter indicating whether the radiation model is used
                 sun_up    = .TRUE.,                   & !< flag parameter indicating whether the sun is up or down
-                sw_radiation = .TRUE.,                 & !< flag parameter indicing whether shortwave radiation shall be calculated
-                sun_direction = .FALSE.                 !< flag parameter indicing whether solar direction shall be calculated
+                sw_radiation = .TRUE.,                & !< flag parameter indicating whether shortwave radiation shall be calculated
+                sun_direction = .FALSE.,              & !< flag parameter indicating whether solar direction shall be calculated
+                average_radiation = .TRUE.,           & !< flag to set the calculation of radiation averaging for the domain
+                atm_surfaces = .FALSE.,               & !< flag parameter indicating wheather surfaces of atmospheric cells will be considered in calculating SVF
+                radiation_interactions = .TRUE.,      & !< flag to control if radiation interactions via sky-view factors shall be considered
+                surf_reflections = .TRUE.               !< flag to switch the calculation of radiation interaction between surfaces.
+                                                        !< When it switched off, only the effect of buildings and trees shadow will
+                                                        !< will be considered. However fewer SVFs are expected.
 
 
@@ -320,11 +362,5 @@
                                  sun_dir_lon       !< solar directional vector in longitudes
 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: &
-                alpha,                       & !< surface broadband albedo (used for clear-sky scheme)
-                emis,                        & !< surface broadband emissivity
-                rad_lw_out_change_0,         & !< change in LW out due to change in surface temperature
-                rad_net,                     & !< net radiation at the surface
-                rad_net_av                     !< average of rad_net
-
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  rad_net_av   !< average of rad_net
 !
 !-- Land surface albedos for solar zenith angle of 60Â° after Briegleb (1992)     
@@ -420,9 +456,5 @@
                                            t_snd          !< actual temperature from sounding data (hPa)
 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: aldif,          & !< longwave diffuse albedo solar angle of 60Â°
-                                             aldir,          & !< longwave direct albedo solar angle of 60Â°
-                                             asdif,          & !< shortwave diffuse albedo solar angle of 60Â°
-                                             asdir,          & !< shortwave direct albedo solar angle of 60Â°
-                                             rrtm_ccl4vmr,   & !< CCL4 volume mixing ratio (g/mol)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: rrtm_ccl4vmr,   & !< CCL4 volume mixing ratio (g/mol)
                                              rrtm_cfc11vmr,  & !< CFC11 volume mixing ratio (g/mol)
                                              rrtm_cfc12vmr,  & !< CFC12 volume mixing ratio (g/mol)
@@ -433,5 +465,5 @@
                                              rrtm_cliqwp,    & !< in-cloud liquid water path (g/mÂ²)
                                              rrtm_co2vmr,    & !< CO2 volume mixing ratio (g/mol)
-                                             rrtm_emis,      & !< surface emissivity (0-1)    
+                                             rrtm_emis,      & !< surface emissivity (0-1)  
                                              rrtm_h2ovmr,    & !< H2O volume mixing ratio
                                              rrtm_n2ovmr,    & !< N2O volume mixing ratio
@@ -459,4 +491,10 @@
                                              rrtm_swhrc        !< RRTM output of incoming shortwave clear sky radiation heating rate (K/d) 
 
+
+    REAL(wp), DIMENSION(1) ::                rrtm_aldif,     & !< surface albedo for longwave diffuse radiation
+                                             rrtm_aldir,     & !< surface albedo for longwave direct radiation
+                                             rrtm_asdif,     & !< surface albedo for shortwave diffuse radiation
+                                             rrtm_asdir        !< surface albedo for shortwave direct radiation
+
 !
 !-- Definition of arrays that are currently not used for calling RRTMG (due to setting of flag parameters)
@@ -465,8 +503,4 @@
                                                 rad_sw_cs_in,   & !< incoming clear sky shortwave radiation (W/m2) (not used)
                                                 rad_sw_cs_out,  & !< outgoing clear sky shortwave radiation (W/m2) (not used)
-                                                rrtm_aldif,     & !< surface albedo for longwave diffuse radiation
-                                                rrtm_aldir,     & !< surface albedo for longwave direct radiation
-                                                rrtm_asdif,     & !< surface albedo for shortwave diffuse radiation
-                                                rrtm_asdir,     & !< surface albedo for shortwave direct radiation
                                                 rrtm_lw_tauaer, & !< lw aerosol optical depth
                                                 rrtm_lw_taucld, & !< lw in-cloud optical depth
@@ -481,4 +515,199 @@
 
 #endif
+!
+!-- Parameters of urban and land surface models
+    INTEGER(iwp)                                   ::  nzu                                !< number of layers of urban surface (will be calculated)
+    INTEGER(iwp)                                   ::  nzub,nzut                          !< bottom and top layer of urban surface (will be calculated)
+!-- parameters of urban and land surface models
+    INTEGER(iwp), PARAMETER                        ::  nzut_free = 3                      !< number of free layers above top of of topography
+    INTEGER(iwp), PARAMETER                        ::  ndsvf = 2                          !< number of dimensions of real values in SVF
+    INTEGER(iwp), PARAMETER                        ::  idsvf = 2                          !< number of dimensions of integer values in SVF
+    INTEGER(iwp), PARAMETER                        ::  ndcsf = 2                          !< number of dimensions of real values in CSF
+    INTEGER(iwp), PARAMETER                        ::  idcsf = 2                          !< number of dimensions of integer values in CSF
+    INTEGER(iwp), PARAMETER                        ::  kdcsf = 4                          !< number of dimensions of integer values in CSF calculation array
+    INTEGER(iwp), PARAMETER                        ::  id = 1                             !< position of d-index in surfl and surf
+    INTEGER(iwp), PARAMETER                        ::  iz = 2                             !< position of k-index in surfl and surf
+    INTEGER(iwp), PARAMETER                        ::  iy = 3                             !< position of j-index in surfl and surf
+    INTEGER(iwp), PARAMETER                        ::  ix = 4                             !< position of i-index in surfl and surf
+
+    INTEGER(iwp), PARAMETER                        ::  nsurf_type = 21                    !< number of surf types incl. phys.(land+urban) & (atm.,sky,boundary) surfaces - 1
+
+    INTEGER(iwp), PARAMETER                        ::  iup_u    = 0                       !< 0 - index of urban ubward surface (ground or roof)
+    INTEGER(iwp), PARAMETER                        ::  idown_u  = 1                       !< 1 - index of urban downward surface (overhanging)
+    INTEGER(iwp), PARAMETER                        ::  inorth_u = 2                       !< 2 - index of urban northward facing wall
+    INTEGER(iwp), PARAMETER                        ::  isouth_u = 3                       !< 3 - index of urban southward facing wall
+    INTEGER(iwp), PARAMETER                        ::  ieast_u  = 4                       !< 4 - index of urban eastward facing wall
+    INTEGER(iwp), PARAMETER                        ::  iwest_u  = 5                       !< 5 - index of urban westward facing wall
+
+    INTEGER(iwp), PARAMETER                        ::  iup_l    = 6                       !< 6 - index of land ubward surface (ground or roof)
+    INTEGER(iwp), PARAMETER                        ::  inorth_l = 7                       !< 7 - index of land northward facing wall
+    INTEGER(iwp), PARAMETER                        ::  isouth_l = 8                       !< 8 - index of land southward facing wall
+    INTEGER(iwp), PARAMETER                        ::  ieast_l  = 9                       !< 9 - index of land eastward facing wall
+    INTEGER(iwp), PARAMETER                        ::  iwest_l  = 10                      !< 10- index of land westward facing wall
+
+    INTEGER(iwp), PARAMETER                        ::  iup_a    = 11                      !< 11- index of atm. cell ubward virtual surface
+    INTEGER(iwp), PARAMETER                        ::  idown_a  = 12                      !< 12- index of atm. cell downward virtual surface
+    INTEGER(iwp), PARAMETER                        ::  inorth_a = 13                      !< 13- index of atm. cell northward facing virtual surface
+    INTEGER(iwp), PARAMETER                        ::  isouth_a = 14                      !< 14- index of atm. cell southward facing virtual surface
+    INTEGER(iwp), PARAMETER                        ::  ieast_a  = 15                      !< 15- index of atm. cell eastward facing virtual surface
+    INTEGER(iwp), PARAMETER                        ::  iwest_a  = 16                      !< 16- index of atm. cell westward facing virtual surface
+
+    INTEGER(iwp), PARAMETER                        ::  isky     = 17                      !< 17 - index of top border of the urban surface layer ("urban sky")
+    INTEGER(iwp), PARAMETER                        ::  inorth_b = 18                      !< 18 - index of free north border of the domain (south facing)
+    INTEGER(iwp), PARAMETER                        ::  isouth_b = 19                      !< 19 - index of north south border of the domain (north facing)
+    INTEGER(iwp), PARAMETER                        ::  ieast_b  = 20                      !< 20 - index of east border of the domain (west facing)
+    INTEGER(iwp), PARAMETER                        ::  iwest_b  = 21                      !< 21 - index of wast border of the domain (east facing)
+
+    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  idir = (/0, 0,0, 0,1,-1,0,0, 0,1,-1,0, 0,0, 0,1,-1, 0, 0,0,-1,1/)   !< surface normal direction x indices
+    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  jdir = (/0, 0,1,-1,0, 0,0,1,-1,0, 0,0, 0,1,-1,0, 0, 0,-1,1, 0,0/)   !< surface normal direction y indices
+    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  kdir = (/1,-1,0, 0,0, 0,1,0, 0,0, 0,1,-1,0, 0,0, 0,-1, 0,0, 0,0/)   !< surface normal direction z indices
+                                                                                          !< parameter but set in the code
+
+
+!-- indices and sizes of urban and land surface models
+    INTEGER(iwp)                                   ::  nskys            !< number of sky surfaces in local processor
+    INTEGER(iwp)                                   ::  startland        !< start index of block of land and roof surfaces!-- block variables needed for calculation of the plant canopy model inside the urban surface model
+    INTEGER(iwp)                                   ::  endland          !< end index of block of land and roof surfaces    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  pct              !< top layer of the plant canopy
+    INTEGER(iwp)                                   ::  nlands           !< number of land and roof surfaces in local processor    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  pch              !< heights of the plant canopy
+    INTEGER(iwp)                                   ::  startwall        !< start index of block of wall surfaces    INTEGER(iwp)                                   ::  npcbl            !< number of the plant canopy gridboxes in local processor
+    INTEGER(iwp)                                   ::  endwall          !< end index of block of wall surfaces    INTEGER(wp), DIMENSION(:,:), ALLOCATABLE       ::  pcbl             !< k,j,i coordinates of l-th local plant canopy box pcbl[:,l] = [k, j,
+    INTEGER(iwp)                                   ::  nwalls           !< number of wall surfaces in local processor    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinsw          !< array of absorbed sw radiation for local plant canopy box
+    INTEGER(iwp)                                   ::  nborder          !< number of border surfaces in local processor    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinlw          !< array of absorbed lw radiation for local plant canopy box
+
+
+!-- indices and sizes of urban and land surface models
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  surfl            !< coordinates of i-th local surface in local grid - surfl[:,k] = [d, z, y, x]
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  surf             !< coordinates of i-th surface in grid - surf[:,k] = [d, z, y, x]
+    INTEGER(iwp)                                   ::  nsurfl           !< number of all surfaces in local processor
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  nsurfs           !< array of number of all surfaces in individual processors
+    INTEGER(iwp)                                   ::  startsky         !< start index of block of sky
+    INTEGER(iwp)                                   ::  endsky           !< end index of block of sky
+    INTEGER(iwp)                                   ::  startenergy      !< start index of block of real surfaces (land, walls and roofs)
+    INTEGER(iwp)                                   ::  endenergy        !< end index of block of real surfaces (land, walls and roofs)
+    INTEGER(iwp)                                   ::  nenergy          !< number of real surfaces in local processor
+    INTEGER(iwp)                                   ::  nsurf            !< global number of surfaces in index array of surfaces (nsurf = proc nsurfs)
+    INTEGER(iwp)                                   ::  startborder      !< start index of block of border
+    INTEGER(iwp)                                   ::  endborder        !< end index of block of border
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  surfstart        !< starts of blocks of surfaces for individual processors in array surf
+                                                                        !< respective block for particular processor is surfstart[iproc]+1 : surfstart[iproc+1]
+
+!-- block variables needed for calculation of the plant canopy model inside the urban surface model
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  pct              !< top layer of the plant canopy
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  pch              !< heights of the plant canopy
+    INTEGER(iwp)                                   ::  npcbl            !< number of the plant canopy gridboxes in local processor
+    INTEGER(wp), DIMENSION(:,:), ALLOCATABLE       ::  pcbl             !< k,j,i coordinates of l-th local plant canopy box pcbl[:,l] = [k, j, i]
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinsw          !< array of absorbed sw radiation for local plant canopy box
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinlw          !< array of absorbed lw radiation for local plant canopy box
+
+!-- configuration parameters (they can be setup in PALM config)
+    LOGICAL                                        ::  split_diffusion_radiation = .TRUE. !< split direct and diffusion dw radiation
+                                                                                          !< (.F. in case the radiation model already does it)    
+    LOGICAL                                        ::  energy_balance_surf_h = .TRUE.     !< flag parameter indicating wheather the energy balance is calculated for horizontal surfaces
+    LOGICAL                                        ::  energy_balance_surf_v = .TRUE.     !< flag parameter indicating wheather the energy balance is calculated for vertical surfaces
+    LOGICAL                                        ::  read_svf_on_init = .FALSE.         !< flag parameter indicating wheather SVFs will be read from a file at initialization
+    LOGICAL                                        ::  write_svf_on_init = .FALSE.        !< flag parameter indicating wheather SVFs will be written out to a file
+    LOGICAL                                        ::  mrt_factors = .FALSE.              !< whether to generate MRT factor files during init
+    INTEGER(iwp)                                   ::  nrefsteps = 0                      !< number of reflection steps to perform
+    REAL(wp), PARAMETER                            ::  ext_coef = 0.6_wp                  !< extinction coefficient (a.k.a. alpha)
+    INTEGER(iwp), PARAMETER                        ::  svf_code_len = 15                  !< length of code for verification of the end of svf file
+    CHARACTER(svf_code_len), PARAMETER             ::  svf_code = '*** end svf ***'       !< code for verification of the end of svf file
+    INTEGER(iwp), PARAMETER                        ::  usm_version_len = 10               !< length of identification string of usm version
+    CHARACTER(usm_version_len), PARAMETER          ::  usm_version = 'USM v. 1.0'         !< identification of version of binary svf and restart files
+
+!-- radiation related arrays to be used in radiation_interaction routine
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  rad_sw_in_dir    !< direct sw radiation
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  rad_sw_in_diff   !< diffusion sw radiation
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  rad_lw_in_diff   !< diffusion lw radiation
+
+!-- parameters required for RRTMG lower boundary condition
+    REAL(wp)                   :: albedo_urb      !< albedo value retuned to RRTMG boundary cond.
+    REAL(wp)                   :: emissivity_urb  !< emissivity value retuned to RRTMG boundary cond.
+    REAL(wp)                   :: t_rad_urb       !< temperature value retuned to RRTMG boundary cond.
+
+!-- type for calculation of svf
+    TYPE t_svf
+        INTEGER(iwp)                               :: isurflt           !< 
+        INTEGER(iwp)                               :: isurfs            !< 
+        REAL(wp)                                   :: rsvf              !< 
+        REAL(wp)                                   :: rtransp           !< 
+    END TYPE
+
+!-- type for calculation of csf
+    TYPE t_csf
+        INTEGER(iwp)                               :: ip                !< 
+        INTEGER(iwp)                               :: itx               !< 
+        INTEGER(iwp)                               :: ity               !< 
+        INTEGER(iwp)                               :: itz               !< 
+        INTEGER(iwp)                               :: isurfs            !< 
+        REAL(wp)                                   :: rsvf              !< 
+        REAL(wp)                                   :: rtransp           !< 
+    END TYPE
+
+!-- arrays storing the values of USM
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  svfsurf          !< svfsurf[:,isvf] = index of source and target surface for svf[isvf]
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  svf              !< array of shape view factors+direct irradiation factors for local surfaces
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfins          !< array of sw radiation falling to local surface after i-th reflection
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinl          !< array of lw radiation for local surface after i-th reflection
+    
+                                                                        !< Inward radiation is also valid for virtual surfaces (radiation leaving domain)
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinsw         !< array of sw radiation falling to local surface including radiation from reflections
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinlw         !< array of lw radiation falling to local surface including radiation from reflections
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinswdir      !< array of direct sw radiation falling to local surface
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinswdif      !< array of diffuse sw radiation from sky and model boundary falling to local surface
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinlwdif      !< array of diffuse lw radiation from sky and model boundary falling to local surface
+    
+                                                                        !< Outward radiation is only valid for nonvirtual surfaces
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfoutsl        !< array of reflected sw radiation for local surface in i-th reflection
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfoutll        !< array of reflected + emitted lw radiation for local surface in i-th reflection
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfouts         !< array of reflected sw radiation for all surfaces in i-th reflection
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfoutl         !< array of reflected + emitted lw radiation for all surfaces in i-th reflection
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfoutsw        !< array of total sw radiation outgoing from nonvirtual surfaces surfaces after all reflection
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfoutlw        !< array of total lw radiation outgoing from nonvirtual surfaces surfaces after all reflection
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfhf           !< array of total radiation flux incoming to minus outgoing from local surface
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  rad_net_l        !< local copy of rad_net (net radiation at surface)
+
+!-- block variables needed for calculation of the plant canopy model inside the urban surface model
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  csfsurf          !< csfsurf[:,icsf] = index of target surface and csf grid index for csf[icsf]
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  csf              !< array of plant canopy sink fators + direct irradiation factors (transparency)
+    REAL(wp), DIMENSION(:,:,:), POINTER            ::  usm_lad          !< subset of lad_s within urban surface, transformed to plain Z coordinate
+    REAL(wp), DIMENSION(:), POINTER                ::  usm_lad_g        !< usm_lad globalized (used to avoid MPI RMA calls in raytracing)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  nzterr, plantt   !< temporary global arrays for raytracing
+
+!-- arrays and variables for calculation of svf and csf
+    TYPE(t_svf), DIMENSION(:), POINTER             ::  asvf             !< pointer to growing svc array
+    TYPE(t_csf), DIMENSION(:), POINTER             ::  acsf             !< pointer to growing csf array
+    TYPE(t_svf), DIMENSION(:), ALLOCATABLE, TARGET ::  asvf1, asvf2     !< realizations of svf array
+    TYPE(t_csf), DIMENSION(:), ALLOCATABLE, TARGET ::  acsf1, acsf2     !< realizations of csf array
+    INTEGER(iwp)                                   ::  nsvfla           !< dimmension of array allocated for storage of svf in local processor
+    INTEGER(iwp)                                   ::  ncsfla           !< dimmension of array allocated for storage of csf in local processor
+    INTEGER(iwp)                                   ::  msvf, mcsf       !< mod for swapping the growing array
+    INTEGER(iwp), PARAMETER                        ::  gasize = 10000   !< initial size of growing arrays
+    REAL(wp)                                       ::  dist_max_svf = -9999.0 !< maximum distance to calculate the minimum svf to be considered. It is
+                                                                        !< used to avoid very small SVFs resulting from too far surfaces with mutual visibility
+    INTEGER(iwp)                                   ::  nsvfl            !< number of svf for local processor
+    INTEGER(iwp)                                   ::  ncsfl            !< no. of csf in local processor
+                                                                        !< needed only during calc_svf but must be here because it is
+                                                                        !< shared between subroutines usm_calc_svf and usm_raytrace
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE    ::  gridpcbl         !< index of local pcb[k,j,i]
+
+!-- temporary arrays for calculation of csf in raytracing
+    INTEGER(iwp)                                   ::  maxboxesg        !< max number of boxes ray can cross in the domain
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  boxes            !< coordinates of gridboxes being crossed by ray
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  crlens           !< array of crossing lengths of ray for particular grid boxes
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  lad_ip           !< array of numbers of process where lad is stored 
+#if defined( __parallel )
+    INTEGER(kind=MPI_ADDRESS_KIND), &
+                  DIMENSION(:), ALLOCATABLE        ::  lad_disp         !< array of displaycements of lad in local array of proc lad_ip
+#endif
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  lad_s_ray        !< array of received lad_s for appropriate gridboxes crossed by ray 
+
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!-- Energy balance variables
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!-- parameters of the land, roof and wall surfaces
+    REAL(wp), DIMENSION(:), ALLOCATABLE            :: albedo_surf        !< albedo of the surface
+    REAL(wp), DIMENSION(:), ALLOCATABLE            :: emiss_surf         !< emissivity of the wall surface
+
 
     INTERFACE radiation_check_data_output
@@ -555,4 +784,29 @@
     END INTERFACE radiation_last_actions
 
+    INTERFACE radiation_interaction
+       MODULE PROCEDURE radiation_interaction
+    END INTERFACE radiation_interaction
+
+    INTERFACE radiation_interaction_init
+       MODULE PROCEDURE radiation_interaction_init
+    END INTERFACE radiation_interaction_init
+
+    INTERFACE radiation_radflux_gridbox
+       MODULE PROCEDURE radiation_radflux_gridbox
+    END INTERFACE radiation_radflux_gridbox
+
+    INTERFACE radiation_calc_svf
+       MODULE PROCEDURE radiation_calc_svf
+    END INTERFACE radiation_calc_svf
+
+    INTERFACE radiation_write_svf
+       MODULE PROCEDURE radiation_write_svf
+    END INTERFACE radiation_write_svf
+
+    INTERFACE radiation_read_svf
+       MODULE PROCEDURE radiation_read_svf
+    END INTERFACE radiation_read_svf
+
+
     SAVE
 
